n, q, k = map(int, input().split())
p = list(map(int, input().split()))
lr = [list(map(int, input().split())) for _ in range(q)]
dela = {i: 0 for i in range(1, n+1)}
current_list = list(dela.keys())
for l, r in lr:
    do, srez, posle = current_list[:l-1], current_list[l-1:r], current_list[r:]
    for delo, prioritet in zip(srez, p):
        dela[delo] = prioritet
    del current_list[l-1:r]
    current_list = do + sorted(srez, key=lambda x: dela[x]) + posle
print(current_list[k-1])
